function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));

var HighlightMatches = (function (PureComponent) {
    function HighlightMatches(props) {
        PureComponent.call(this, props);
    }

    if ( PureComponent ) HighlightMatches.__proto__ = PureComponent;
    HighlightMatches.prototype = Object.create( PureComponent && PureComponent.prototype );
    HighlightMatches.prototype.constructor = HighlightMatches;
    HighlightMatches.prototype.render = function render () {
        var ref = this.props;
        var tag = ref.tag;
        var component = ref.component;
        var text = ref.text;
        var render = ref.render;
        var tags = ref.tags; if ( tags === void 0 ) tags = [{
            tag: tag,
            component: component,
            render: render
        }];
        var ContainerComponent = ref.containerComponent; if ( ContainerComponent === void 0 ) ContainerComponent = 'span';
        var tagStrings = tags.map(function (ref) {
            var tag = ref.tag;

            return tag;
        }).join('|');
        var matchRegex = new RegExp(("(<(?:" + tagStrings + ")>.*?</(?:" + tagStrings + ")>)"), 'g');
        var result = text.split(matchRegex).map(function (split, i) {
            var matchingTag = tags.find(function (ref) {
                var tag = ref.tag;

                var matchRegex = new RegExp(("(<" + tag + ">.*?</" + tag + ">)"), 'g');
                return Boolean(split.match(matchRegex));
            });
            if (!matchingTag) {
                return split;
            }
            var Component = matchingTag.component;
            var render = matchingTag.render;
            var tag = matchingTag.tag;
            var replaceRegex = new RegExp(("<" + tag + ">(.*?)</" + tag + ">"), 'g');
            var text = split.replace(replaceRegex, '$1');
            if (typeof render === 'function') {
                return render({
                    text: text,
                    key: i
                });
            }
            return /*JSXElement?*/ React__default.createElement( Component, { key: i }, text);
        });
        return /*JSXElement?*/ React__default.createElement( ContainerComponent, null, result );
    };

    return HighlightMatches;
}(React.PureComponent));
HighlightMatches.propTypes = {
    text: PropTypes.string.isRequired,
    tag: PropTypes.string,
    tags: PropTypes.arrayOf(PropTypes.shape({
        tag: PropTypes.string.isRequired,
        component: PropTypes.any,
        render: PropTypes.func
    })),
    component: PropTypes.any,
    render: PropTypes.func
};
module.exports = HighlightMatches;
//# sourceMappingURL=index.js.map
